import { PartialMessage, Plugin } from 'esbuild';
import { CSSModulesConfig } from 'lightningcss';

/** Convert less error into esbuild error */
declare const convertLessError: (error: Less.RenderError) => PartialMessage;

type StyleTransformResult = {
    css: string;
    map?: string;
    imports?: string[];
    warnings?: PartialMessage[];
};

declare const transformLess: (filePath: string, options: {
    sourcemap: boolean;
    alias?: Record<string, string>;
}) => Promise<StyleTransformResult>;

type StyleLoaderOptions = {
    filter?: RegExp;
    namespace?: string[];
    cssModules?: CSSModulesConfig;
    browsers?: string;
    publicPath?: string;
};
declare const styleLoader: (options?: StyleLoaderOptions) => Plugin;

export { convertLessError, styleLoader, transformLess };
